Index: cpukit/score/include/rtems/score/schedulerimpl.h
===================================================================
--- cpukit/score/include/rtems/score/schedulerimpl.h	(revision 0dd49d001515897cceb9195eb97dfac683552a0b)
+++ cpukit/score/include/rtems/score/schedulerimpl.h	(revision 9e7fa07169083baebcac7aea9b13c61a8c27660e)
@@ -1215,8 +1215,5 @@
   Scheduler_Node *old_scheduler_node;
 
-  if (
-    _Thread_Owns_resources( the_thread )
-      || the_thread->Wait.queue != NULL
-  ) {
+  if ( the_thread->Wait.queue != NULL ) {
     return STATUS_RESOURCE_IN_USE;
   }
@@ -1238,4 +1235,8 @@
 
 #if defined(RTEMS_SMP)
+  if ( !_Chain_Has_only_one_node( &the_thread->Scheduler.Wait_nodes ) ) {
+    return STATUS_RESOURCE_IN_USE;
+  }
+
   _Thread_Scheduler_process_requests( the_thread );
   new_scheduler_node = _Thread_Scheduler_get_node_by_index(
Index: testsuites/smptests/smpscheduler02/init.c
===================================================================
--- testsuites/smptests/smpscheduler02/init.c	(revision 0dd49d001515897cceb9195eb97dfac683552a0b)
+++ testsuites/smptests/smpscheduler02/init.c	(revision 9e7fa07169083baebcac7aea9b13c61a8c27660e)
@@ -26,6 +26,4 @@
 const char rtems_test_name[] = "SMPSCHEDULER 2";
 
-#if defined(__RTEMS_HAVE_SYS_CPUSET_H__)
-
 #define SCHED_A rtems_build_name(' ', ' ', ' ', 'A')
 
@@ -36,5 +34,7 @@
 static rtems_id main_task_id;
 
-static rtems_id sema_id;
+static rtems_id cmtx_id;
+
+static rtems_id imtx_id;
 
 static void task(rtems_task_argument arg)
@@ -48,6 +48,15 @@
   rtems_test_assert(sched_get_priority_max(SCHED_RR) == 126);
 
-  sc = rtems_semaphore_obtain(sema_id, RTEMS_WAIT, RTEMS_NO_TIMEOUT);
+  sc = rtems_semaphore_obtain(cmtx_id, RTEMS_WAIT, RTEMS_NO_TIMEOUT);
   rtems_test_assert(sc == RTEMS_NOT_DEFINED);
+
+  sc = rtems_event_transient_send(main_task_id);
+  rtems_test_assert(sc == RTEMS_SUCCESSFUL);
+
+  sc = rtems_semaphore_obtain(imtx_id, RTEMS_WAIT, RTEMS_NO_TIMEOUT);
+  rtems_test_assert(sc == RTEMS_SUCCESSFUL);
+
+  sc = rtems_semaphore_release(imtx_id);
+  rtems_test_assert(sc == RTEMS_SUCCESSFUL);
 
   sc = rtems_event_transient_send(main_task_id);
@@ -103,14 +112,23 @@
 
   sc = rtems_semaphore_create(
-    SCHED_A,
+    rtems_build_name('C', 'M', 'T', 'X'),
     1,
     RTEMS_BINARY_SEMAPHORE | RTEMS_PRIORITY | RTEMS_PRIORITY_CEILING,
     1,
-    &sema_id
+    &cmtx_id
   );
   rtems_test_assert(sc == RTEMS_SUCCESSFUL);
 
+  sc = rtems_semaphore_create(
+    rtems_build_name('I', 'M', 'T', 'X'),
+    1,
+    RTEMS_BINARY_SEMAPHORE | RTEMS_PRIORITY | RTEMS_INHERIT_PRIORITY,
+    1,
+    &imtx_id
+  );
+  rtems_test_assert(sc == RTEMS_SUCCESSFUL);
+
   prio = 2;
-  sc = rtems_semaphore_set_priority(sema_id, scheduler_a_id, prio, &prio);
+  sc = rtems_semaphore_set_priority(cmtx_id, scheduler_a_id, prio, &prio);
   rtems_test_assert(sc == RTEMS_SUCCESSFUL);
   rtems_test_assert(prio == 1);
@@ -118,5 +136,5 @@
   if (cpu_count > 1) {
     prio = 1;
-    sc = rtems_semaphore_set_priority(sema_id, scheduler_b_id, prio, &prio);
+    sc = rtems_semaphore_set_priority(cmtx_id, scheduler_b_id, prio, &prio);
     rtems_test_assert(sc == RTEMS_NOT_DEFINED);
     rtems_test_assert(prio == 2);
@@ -198,4 +216,7 @@
     rtems_test_assert(scheduler_id == scheduler_b_id);
 
+    sc = rtems_semaphore_obtain(imtx_id, RTEMS_WAIT, RTEMS_NO_TIMEOUT);
+    rtems_test_assert(sc == RTEMS_SUCCESSFUL);
+
     sc = rtems_task_start(task_id, task, 0);
     rtems_test_assert(sc == RTEMS_SUCCESSFUL);
@@ -206,4 +227,13 @@
     sc = rtems_event_transient_receive(RTEMS_WAIT, RTEMS_NO_TIMEOUT);
     rtems_test_assert(sc == RTEMS_SUCCESSFUL);
+
+    sc = rtems_task_set_scheduler(RTEMS_SELF, scheduler_b_id, 1);
+    rtems_test_assert(sc == RTEMS_RESOURCE_IN_USE);
+
+    sc = rtems_semaphore_release(imtx_id);
+    rtems_test_assert(sc == RTEMS_SUCCESSFUL);
+
+    sc = rtems_event_transient_receive(RTEMS_WAIT, RTEMS_NO_TIMEOUT);
+    rtems_test_assert(sc == RTEMS_SUCCESSFUL);
   }
 
@@ -211,16 +241,10 @@
   rtems_test_assert(sc == RTEMS_SUCCESSFUL);
 
-  sc = rtems_semaphore_delete(sema_id);
+  sc = rtems_semaphore_delete(cmtx_id);
+  rtems_test_assert(sc == RTEMS_SUCCESSFUL);
+
+  sc = rtems_semaphore_delete(imtx_id);
   rtems_test_assert(sc == RTEMS_SUCCESSFUL);
 }
-
-#else /* defined(__RTEMS_HAVE_SYS_CPUSET_H__) */
-
-static void test(void)
-{
-  /* Nothing to do */
-}
-
-#endif /* defined(__RTEMS_HAVE_SYS_CPUSET_H__) */
 
 static void Init(rtems_task_argument arg)
@@ -244,5 +268,5 @@
 
 #define CONFIGURE_MAXIMUM_TASKS 2
-#define CONFIGURE_MAXIMUM_SEMAPHORES 1
+#define CONFIGURE_MAXIMUM_SEMAPHORES 2
 
 #define CONFIGURE_SMP_APPLICATION
Index: testsuites/sptests/spscheduler01/init.c
===================================================================
--- testsuites/sptests/spscheduler01/init.c	(revision 0dd49d001515897cceb9195eb97dfac683552a0b)
+++ testsuites/sptests/spscheduler01/init.c	(revision 9e7fa07169083baebcac7aea9b13c61a8c27660e)
@@ -237,5 +237,5 @@
 
   sc = rtems_task_set_scheduler(self_id, scheduler_id, 1);
-  rtems_test_assert(sc == RTEMS_RESOURCE_IN_USE);
+  rtems_test_assert(sc == RTEMS_SUCCESSFUL);
 
   sc = rtems_semaphore_release(mtx_id);
